class AS::Gamestate	
	@@current = nil
	
	def initialize
		@actions = {}
		@textures = AS::TextureManager.new
	end
	
	def action(event, &proc)
		@actions[event] = proc
	end
	
	def self.tex(name)
		@@current.tex(name)
	end
	
	def tex(name)
		@textures[name]
	end
	
	def events
		AS::Event.each(&method(:input))
	end
	
	def input(event)
		proc = @actions[event]
		proc.call if proc
	end
		
	def run
		@oldState, @@current = @@current, self
		@oldState.pause if @oldState
		@active = true
		
		resume
		while(@active)
			events
			update
			
			GL.Clear(GL::COLOR_BUFFER_BIT)
			draw
			AS.swap_buffers
		end
		
		@@current.pause
		@@current = @oldState
		@oldState.resume if @oldState
		
		return @ret
	end
	
	def pause
		@textures.release
	end
	
	def resume
		@textures.reload
	end
	
	def self.stop(ret = nil)
		@@current.stop(ret)
	end
	
	def stop(ret = nil)
		@active = false
		@ret = ret
	end
end