class AS::TextureManager
	def initialize
		@hash = Hash.new
	end
	
	def [](name)
		tex = @hash[name]
		unless tex
			tex = AS::Texture.open(name)
			@hash[name] = tex
		end
		
		return tex
	end
	
	def release(name = nil)
		if name
			@hash[name].release
		else
#			puts "releasing all"
			@hash.each_value{|tex| tex.release}
		end
	end
	
	
	def reload(name = nil)
		if name
			@hash[name].reload
		else
			@hash.each do|name, tex|
				if tex.num == 0
					tex.reload(name)
#					puts "reloading #{name}"
				end
			end
		end
	end
	
	def remove(name)
		@hash[name].release
		@hash.delete(name)
	end
	
	def self.manage(manager)
		@@active = manager
		yield
		@@active = nil
	end
	
	def self.tex(name)
		raise "No active TextureManager" unless @@active
		@@active[name]
	end
end